program editor;

{$APPTYPE CONSOLE}

uses
  Windows,
  madRes;

function ReadSettings(ServerFile: string): string;
var
  ServerModule: HMODULE;
  ResourceLocation: HRSRC;
  ResourceSize: dword;
  ResourceHandle: THandle;
  ResourcePointer: pointer;
begin
  ServerModule := LoadLibrary(pchar(ServerFile));
  try
    ResourceLocation := FindResource(ServerModule, 'SETTINGS', RT_RCDATA);
    ResourceSize := SizeofResource(ServerModule, ResourceLocation);
    ResourceHandle := LoadResource(ServerModule, ResourceLocation);
    ResourcePointer := LockResource(ResourceHandle);
    if ResourcePointer <> nil then
    begin
      SetLength(Result, ResourceSize - 1);
      CopyMemory(@Result[1], ResourcePointer, ResourceSize);
      FreeResource(ResourceHandle);
    end;
  finally
    FreeLibrary(ServerModule);
  end;
end;

procedure WriteSettings(ServerFile: string; Settings: string);
var
  ResourceHandle: THandle;
  pwServerFile: PWideChar;
begin
  GetMem(pwServerFile, (Length(ServerFile) + 1) * 2);
  try
    StringToWideChar(ServerFile, pwServerFile, Length(ServerFile) * 2);
    ResourceHandle := BeginUpdateResourceW(pwServerFile, False);
    UpdateResourceW(ResourceHandle, MakeIntResourceW(10), 'SETTINGS', 0, @Settings[1], Length(Settings) + 1);
    EndUpdateResourceW(ResourceHandle, False);
  finally
    FreeMem(pwServerFile);
  end;
end;

var
  Settings: string;

begin
  Settings := 'EditServer Test';
  WriteSettings('server.exe', Settings);
  WriteLn(ReadSettings('server.exe'));
  ReadLn;
end.
